EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_gfx_image_load_controller_load_async_start);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_gfx_image_load_controller_load_async_cancel);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_image_load_controller_load_size_set, EFL_FUNC_CALL(size), Eina_Size2D size);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_size_get, Eina_Size2D, ((Eina_Size2D){0}));

static Eina_Error
__eolian_efl_gfx_image_load_controller_load_dpi_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   double cval;
   if (!eina_value_double_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_image_load_controller_load_dpi_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_image_load_controller_load_dpi_set, EFL_FUNC_CALL(dpi), double dpi);

static Eina_Value
__eolian_efl_gfx_image_load_controller_load_dpi_get_reflect(const Eo *obj)
{
   double val = efl_gfx_image_load_controller_load_dpi_get(obj);
   return eina_value_double_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_dpi_get, double, 0);

static Eina_Value
__eolian_efl_gfx_image_load_controller_load_region_support_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_image_load_controller_load_region_support_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_region_support_get, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_image_load_controller_load_region_set, EFL_FUNC_CALL(region), Eina_Rect region);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_region_get, Eina_Rect, (EINA_RECT_EMPTY()));

static Eina_Error
__eolian_efl_gfx_image_load_controller_load_orientation_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_image_load_controller_load_orientation_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_image_load_controller_load_orientation_set, EFL_FUNC_CALL(enable), Eina_Bool enable);

static Eina_Value
__eolian_efl_gfx_image_load_controller_load_orientation_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_image_load_controller_load_orientation_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_orientation_get, Eina_Bool, 0);

static Eina_Error
__eolian_efl_gfx_image_load_controller_load_scale_down_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_image_load_controller_load_scale_down_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_image_load_controller_load_scale_down_set, EFL_FUNC_CALL(div), int div);

static Eina_Value
__eolian_efl_gfx_image_load_controller_load_scale_down_get_reflect(const Eo *obj)
{
   int val = efl_gfx_image_load_controller_load_scale_down_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_scale_down_get, int, 0);

static Eina_Error
__eolian_efl_gfx_image_load_controller_load_skip_header_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_image_load_controller_load_skip_header_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_image_load_controller_load_skip_header_set, EFL_FUNC_CALL(skip), Eina_Bool skip);

static Eina_Value
__eolian_efl_gfx_image_load_controller_load_skip_header_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_gfx_image_load_controller_load_skip_header_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_image_load_controller_load_skip_header_get, Eina_Bool, 0);

static Eina_Bool
_efl_gfx_image_load_controller_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_GFX_IMAGE_LOAD_CONTROLLER_EXTRA_OPS
#define EFL_GFX_IMAGE_LOAD_CONTROLLER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_async_start, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_async_cancel, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_size_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_size_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_dpi_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_dpi_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_region_support_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_region_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_region_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_orientation_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_orientation_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_scale_down_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_scale_down_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_skip_header_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_image_load_controller_load_skip_header_get, NULL),
      EFL_GFX_IMAGE_LOAD_CONTROLLER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"load_dpi", __eolian_efl_gfx_image_load_controller_load_dpi_set_reflect, __eolian_efl_gfx_image_load_controller_load_dpi_get_reflect},
      {"load_region_support", NULL, __eolian_efl_gfx_image_load_controller_load_region_support_get_reflect},
      {"load_orientation", __eolian_efl_gfx_image_load_controller_load_orientation_set_reflect, __eolian_efl_gfx_image_load_controller_load_orientation_get_reflect},
      {"load_scale_down", __eolian_efl_gfx_image_load_controller_load_scale_down_set_reflect, __eolian_efl_gfx_image_load_controller_load_scale_down_get_reflect},
      {"load_skip_header", __eolian_efl_gfx_image_load_controller_load_skip_header_set_reflect, __eolian_efl_gfx_image_load_controller_load_skip_header_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_gfx_image_load_controller_class_desc = {
   EO_VERSION,
   "Efl.Gfx.Image_Load_Controller",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_gfx_image_load_controller_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_gfx_image_load_controller_interface_get, &_efl_gfx_image_load_controller_class_desc, NULL, NULL);
